Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_transition.cpp	(revision 111)
@@ -0,0 +1,205 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace decod_unit {
+namespace decod_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Decod_queue::function_multi_fifo_transition"
+  void Decod_queue::function_multi_fifo_transition (void)
+  {
+    log_begin(Decod_queue,FUNCTION);
+    log_function(Decod_queue,FUNCTION,_name.c_str());
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+        for (uint32_t i=0; i<_param->_nb_bank; ++i)
+          reg_QUEUE[i].clear();
+
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  reg_NB_INST [i]=0;
+
+        reg_NUM_BANK_HEAD = 0;
+        reg_NUM_BANK_TAIL = 0;
+      }
+    else
+      {
+	//--------------------------------------------------------------------
+	//-----[ DECOD_IN ]---------------------------------------------------
+	//--------------------------------------------------------------------	
+
+        {
+#ifdef STATISTICS
+          bool find = false;
+#endif
+          for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+            if (PORT_READ(in_DECOD_IN_VAL [i]) and internal_DECOD_IN_ACK[i])
+              {
+                log_printf(TRACE,Decod_queue,FUNCTION,_("  * DECOD_IN  [%d]"),i);
+                
+                // Create entry
+                decod_queue_entry_t * entry = new decod_queue_entry_t (1);
+                reg_QUEUE[reg_NUM_BANK_TAIL].push_back(entry);
+                
+#ifdef STATISTICS
+                find = true;
+                if (usage_is_set(_usage,USE_STATISTICS))
+                  (*_stat_sum_inst_enable) ++;
+#endif
+
+		Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_DECOD_IN_CONTEXT_ID [i]):0;
+
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * context : %d"),context);
+
+// 		entry->_val           [0] = 1;
+		entry->_context_id    [0] = context;
+		entry->_depth         [0] = (_param->_have_port_depth)?PORT_READ(in_DECOD_IN_DEPTH [i]):0;
+		entry->_type          [0] = PORT_READ(in_DECOD_IN_TYPE          [i]);
+		entry->_operation     [0] = PORT_READ(in_DECOD_IN_OPERATION     [i]);
+		entry->_no_execute    [0] = PORT_READ(in_DECOD_IN_NO_EXECUTE    [i]);
+		entry->_is_delay_slot [0] = PORT_READ(in_DECOD_IN_IS_DELAY_SLOT [i]);
+#ifdef DEBUG
+		entry->_address       [0] = PORT_READ(in_DECOD_IN_ADDRESS       [i]);
+#endif
+		entry->_address_next  [0] = PORT_READ(in_DECOD_IN_ADDRESS_NEXT  [i]);
+		entry->_has_immediat  [0] = PORT_READ(in_DECOD_IN_HAS_IMMEDIAT  [i]);
+		entry->_immediat      [0] = PORT_READ(in_DECOD_IN_IMMEDIAT      [i]);
+		entry->_read_ra       [0] = PORT_READ(in_DECOD_IN_READ_RA       [i]);
+		entry->_num_reg_ra    [0] = PORT_READ(in_DECOD_IN_NUM_REG_RA    [i]);
+		entry->_read_rb       [0] = PORT_READ(in_DECOD_IN_READ_RB       [i]);
+		entry->_num_reg_rb    [0] = PORT_READ(in_DECOD_IN_NUM_REG_RB    [i]);
+		entry->_read_rc       [0] = PORT_READ(in_DECOD_IN_READ_RC       [i]);
+		entry->_num_reg_rc    [0] = PORT_READ(in_DECOD_IN_NUM_REG_RC    [i]);
+		entry->_write_rd      [0] = PORT_READ(in_DECOD_IN_WRITE_RD      [i]);
+		entry->_num_reg_rd    [0] = PORT_READ(in_DECOD_IN_NUM_REG_RD    [i]);
+		entry->_write_re      [0] = PORT_READ(in_DECOD_IN_WRITE_RE      [i]);
+		entry->_num_reg_re    [0] = PORT_READ(in_DECOD_IN_NUM_REG_RE    [i]);
+		entry->_exception_use [0] = PORT_READ(in_DECOD_IN_EXCEPTION_USE [i]);
+		entry->_exception     [0] = PORT_READ(in_DECOD_IN_EXCEPTION     [i]);
+
+                // Update pointer
+                reg_NUM_BANK_TAIL = (reg_NUM_BANK_TAIL+1)%_param->_nb_bank;
+		reg_NB_INST [context] ++;
+
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * nb_inst : %d"),reg_NB_INST [context]);
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * PUSH queue"));
+	      }
+
+#ifdef STATISTICS
+          if (usage_is_set(_usage,USE_STATISTICS))
+            if (find)
+              (*_stat_sum_transaction_decod_in) ++;
+#endif
+        }
+
+	//--------------------------------------------------------------------
+	//-----[ DECOD_OUT ]--------------------------------------------------
+	//--------------------------------------------------------------------
+        {
+          for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+            if (internal_DECOD_OUT_VAL [i] and internal_DECOD_OUT_ACK[i])
+              {
+                log_printf(TRACE,Decod_queue,FUNCTION,_("  * DECOD_OUT [%d]"),i);
+		
+                uint32_t num_bank = reg_NUM_BANK_HEAD;
+
+                Tcontext_t context = reg_QUEUE[num_bank].front()->_context_id [0];
+
+                log_printf(TRACE,Decod_queue,FUNCTION,_("    * context : %d"),context);
+
+		// Pop the slot
+		delete reg_QUEUE[num_bank].front();
+		reg_QUEUE[num_bank].pop_front();
+
+                // Update pointer
+                reg_NUM_BANK_HEAD = (reg_NUM_BANK_HEAD+1)%_param->_nb_bank;
+		reg_NB_INST [context] --;
+	      }
+        }
+
+	//--------------------------------------------------------------------
+	//-----[ OTHERS ]-----------------------------------------------------
+	//--------------------------------------------------------------------
+
+#if defined(DEBUG) and defined(DEBUG_Decod_queue) and (DEBUG >= DEBUG_TRACE)
+    log_printf(TRACE,Decod_queue,FUNCTION,"  * Dump decod_queue");
+    log_printf(TRACE,Decod_queue,FUNCTION,"    * reg_NUM_BANK_HEAD : %d",reg_NUM_BANK_HEAD);
+    log_printf(TRACE,Decod_queue,FUNCTION,"    * reg_NUM_BANK_TAIL : %d",reg_NUM_BANK_TAIL);
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      log_printf(TRACE,Decod_queue,FUNCTION,"    * reg_NB_INST [%d] : %d",i,reg_NB_INST [i]);
+
+    for (uint32_t i=0; i<_param->_nb_bank; ++i)
+      {
+        uint32_t x=0;
+        uint32_t num_bank = (reg_NUM_BANK_HEAD+i)%_param->_nb_bank;
+        for (std::list<decod_queue_entry_t*>::iterator it=reg_QUEUE[num_bank].begin();
+             it!=reg_QUEUE[num_bank].end();
+             it++)
+          {
+            log_printf(TRACE,Decod_queue,FUNCTION,"    * [%.4d][%.4d] %.3d %.2d, %.2d %.3d %.1d %.1d, 0x%.8x (0x%.8x), %.1d 0x%.8x, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d"
+                       ,i
+                       ,x
+                       ,(*it)->_context_id    [0]
+                       ,(*it)->_depth         [0]
+                       ,(*it)->_type          [0]
+                       ,(*it)->_operation     [0]
+                       ,(*it)->_no_execute    [0]
+                       ,(*it)->_is_delay_slot [0]
+                       ,(*it)->_address       [0]
+                       ,(*it)->_address       [0]<<2
+                       ,(*it)->_has_immediat  [0]
+                       ,(*it)->_immediat      [0]
+                       ,(*it)->_read_ra       [0]
+                       ,(*it)->_num_reg_ra    [0]
+                       ,(*it)->_read_rb       [0]
+                       ,(*it)->_num_reg_rb    [0]
+                       ,(*it)->_read_rc       [0]
+                       ,(*it)->_num_reg_rc    [0]
+                       ,(*it)->_write_rd      [0]
+                       ,(*it)->_num_reg_rd    [0]
+                       ,(*it)->_write_re      [0]
+                       ,(*it)->_num_reg_re    [0]
+                       ,(*it)->_exception_use [0]
+                       ,(*it)->_exception     [0]
+                       );
+            x++;
+	  }
+      }
+#endif
+    
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+        for (uint32_t i=0; i<_param->_nb_bank; ++i)
+          *(_stat_use_queue) += reg_QUEUE[i].size();
+        for (uint32_t i=0; i<_param->_nb_context; i++)
+          *(_stat_nb_inst [i]) += reg_NB_INST [i];
+      }
+#endif
+      }
+
+    log_end(Decod_queue,FUNCTION);
+  };
+  
+}; // end namespace decod_queue
+}; // end namespace decod_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMealy_decod_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMealy_decod_out.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMealy_decod_out.cpp	(revision 111)
@@ -0,0 +1,121 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace decod_unit {
+namespace decod_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Decod_queue::function_one_fifo_genMealy_decod_out"
+  void Decod_queue::function_one_fifo_genMealy_decod_out (void)
+  {
+    log_begin(Decod_queue,FUNCTION);
+    log_function(Decod_queue,FUNCTION,_name.c_str());
+
+    Tcontrol_t val [_param->_nb_inst_decod];
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+	val                    [i] = 0;
+	internal_DECOD_OUT_VAL [i] = 0;
+	internal_DECOD_OUT_ACK [i] = 0;
+      }
+
+    if (not reg_QUEUE->empty())
+      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+        {
+          uint32_t index = reg_LAST_SLOT + i;
+
+          // Stop
+          if (index >= _param->_nb_inst_decod)
+            break;
+
+          if (reg_QUEUE->front()->_val [index])
+            {
+              log_printf(TRACE,Decod_queue,FUNCTION,_("  * Queue is not empty, slot [%d] is valid."),i);
+              
+              Tcontext_t context         = reg_QUEUE->front()->_context_id    [index];
+              Tdepth_t   depth           = reg_QUEUE->front()->_depth         [index];
+              Tdepth_t   depth_min       = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MIN [context]):0;
+              Tdepth_t   depth_max       = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MAX [context]):0;
+              Tcontrol_t depth_full      = PORT_READ(in_DEPTH_FULL[context]);
+
+              // is a valid instruction ?
+              // If DEPTH_CURRENT :
+              // equal at     DEPTH_MIN            -> not speculative
+              // not include ]DEPTH_MIN:DEPTH_MAX] -> previous branch miss
+              //     include ]DEPTH_MIN:DEPTH_MAX] -> speculative
+              
+              // All case
+              // ....... min ...X... max ....... OK
+              // ....... min ....... max ...X... KO
+              // ...X... min ....... max ....... KO
+              // ....... max ....... min ...X... OK
+              // ...X... max ....... min ....... OK
+              // ....... max ...X... min ....... KO
+              
+              Tcontrol_t   is_valid      = ((depth == depth_min) or
+                                            depth_full or
+                                            ((depth_min <= depth_max)?
+                                             ((depth >= depth_min) and (depth <=depth_max)):
+                                             ((depth >= depth_min) or  (depth <=depth_max))));
+              //Tcontrol_t is_valid        = ((depth == depth_min) or 
+              //                              ((depth_min < depth_max)?
+              //                               (depth<=depth_max):
+              //                               ((depth > depth_min) or (depth <= depth_max))));
+              //Tcontrol_t is_valid        = depth <= depth_max;
+
+              log_printf(TRACE,Decod_queue,FUNCTION,"    * is_valid : %d",is_valid);
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * context      : %d",context);
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth        : %d",depth);
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_min    : %d",depth_min);
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_max    : %d",depth_max);
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_full   : %d",depth_full);
+#ifdef DEBUG
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * address      : 0x%x (0x%x)",reg_QUEUE->front()->_address     [index],reg_QUEUE->front()->_address     [index]<<2);
+#endif
+              log_printf(TRACE,Decod_queue,FUNCTION,"      * address_next : 0x%x (0x%x)",reg_QUEUE->front()->_address_next[index],reg_QUEUE->front()->_address_next[index]<<2);
+              internal_DECOD_OUT_VAL [index] = 1; // in all case, val is set (entry is not empty, and instruction is valid)
+              if (is_valid)
+                {
+                  val                    [i]     = 1;
+                  internal_DECOD_OUT_ACK [index] = PORT_READ(in_DECOD_OUT_ACK [i]);
+                }
+              else
+                {
+                  // Consume the instruction (to erase)
+                  internal_DECOD_OUT_ACK [index] = 1;
+                }
+            }
+      }
+
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+        log_printf(TRACE,Decod_queue,FUNCTION,"  * DECOD_OUT_VAL : %d",val [i]);
+        
+        PORT_WRITE(out_DECOD_OUT_VAL [i],val [i]);
+      }
+
+    log_end(Decod_queue,FUNCTION);
+  };
+
+}; // end namespace decod_queue
+}; // end namespace decod_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMoore.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_genMoore.cpp	(revision 111)
@@ -0,0 +1,97 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace decod_unit {
+namespace decod_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Decod_queue::function_one_fifo_genMoore"
+  void Decod_queue::function_one_fifo_genMoore (void)
+  {
+    log_begin(Decod_queue,FUNCTION);
+    log_function(Decod_queue,FUNCTION,_name.c_str());
+
+    //--------------------------------------------------------------------
+    //-----[ DECOD_IN ]---------------------------------------------------
+    //--------------------------------------------------------------------
+    {
+      Tcontrol_t ack = reg_QUEUE->size() < _param->_size_queue;
+
+      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	{
+	  internal_DECOD_IN_ACK [i] = ack;
+	  PORT_WRITE(out_DECOD_IN_ACK [i],ack);
+	}
+    }
+
+    //--------------------------------------------------------------------
+    //-----[ DECOD_OUT ]--------------------------------------------------
+    //--------------------------------------------------------------------
+    if (not reg_QUEUE->empty())
+      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	{
+          uint32_t index = reg_LAST_SLOT + i;
+
+          // Stop
+          if (index >= _param->_nb_inst_decod)
+            break;
+
+	  if (_param->_have_port_context_id)
+	  PORT_WRITE(out_DECOD_OUT_CONTEXT_ID    [i],reg_QUEUE->front()->_context_id    [index]);
+	  if (_param->_have_port_depth)
+	  PORT_WRITE(out_DECOD_OUT_DEPTH         [i],reg_QUEUE->front()->_depth         [index]);
+	  PORT_WRITE(out_DECOD_OUT_TYPE          [i],reg_QUEUE->front()->_type          [index]);
+	  PORT_WRITE(out_DECOD_OUT_OPERATION     [i],reg_QUEUE->front()->_operation     [index]);
+	  PORT_WRITE(out_DECOD_OUT_NO_EXECUTE    [i],reg_QUEUE->front()->_no_execute    [index]);
+	  PORT_WRITE(out_DECOD_OUT_IS_DELAY_SLOT [i],reg_QUEUE->front()->_is_delay_slot [index]);
+#ifdef DEBUG
+	  PORT_WRITE(out_DECOD_OUT_ADDRESS       [i],reg_QUEUE->front()->_address       [index]);
+#endif
+	  PORT_WRITE(out_DECOD_OUT_ADDRESS_NEXT  [i],reg_QUEUE->front()->_address_next  [index]);
+	  PORT_WRITE(out_DECOD_OUT_HAS_IMMEDIAT  [i],reg_QUEUE->front()->_has_immediat  [index]);
+	  PORT_WRITE(out_DECOD_OUT_IMMEDIAT      [i],reg_QUEUE->front()->_immediat      [index]);
+	  PORT_WRITE(out_DECOD_OUT_READ_RA       [i],reg_QUEUE->front()->_read_ra       [index]);
+	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RA    [i],reg_QUEUE->front()->_num_reg_ra    [index]);
+	  PORT_WRITE(out_DECOD_OUT_READ_RB       [i],reg_QUEUE->front()->_read_rb       [index]);
+	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RB    [i],reg_QUEUE->front()->_num_reg_rb    [index]);
+	  PORT_WRITE(out_DECOD_OUT_READ_RC       [i],reg_QUEUE->front()->_read_rc       [index]);
+	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RC    [i],reg_QUEUE->front()->_num_reg_rc    [index]);
+	  PORT_WRITE(out_DECOD_OUT_WRITE_RD      [i],reg_QUEUE->front()->_write_rd      [index]);
+	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RD    [i],reg_QUEUE->front()->_num_reg_rd    [index]);
+	  PORT_WRITE(out_DECOD_OUT_WRITE_RE      [i],reg_QUEUE->front()->_write_re      [index]);
+	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RE    [i],reg_QUEUE->front()->_num_reg_re    [index]);
+	  PORT_WRITE(out_DECOD_OUT_EXCEPTION_USE [i],reg_QUEUE->front()->_exception_use [index]);
+	  PORT_WRITE(out_DECOD_OUT_EXCEPTION     [i],reg_QUEUE->front()->_exception     [index]);
+	}
+
+    //--------------------------------------------------------------------
+    //-----[ NB_INST ]----------------------------------------------------
+    //--------------------------------------------------------------------
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      PORT_WRITE(out_NB_INST_ALL [i], reg_NB_INST [i]);
+
+    log_end(Decod_queue,FUNCTION);
+  };
+
+}; // end namespace decod_queue
+}; // end namespace decod_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_one_fifo_transition.cpp	(revision 111)
@@ -0,0 +1,219 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace decod_unit {
+namespace decod_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Decod_queue::function_one_fifo_transition"
+  void Decod_queue::function_one_fifo_transition (void)
+  {
+    log_begin(Decod_queue,FUNCTION);
+    log_function(Decod_queue,FUNCTION,_name.c_str());
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	reg_QUEUE->clear();
+
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  reg_NB_INST [i]=0;
+
+        reg_LAST_SLOT = 0;
+      }
+    else
+      {
+	//--------------------------------------------------------------------
+	//-----[ DECOD_IN ]---------------------------------------------------
+	//--------------------------------------------------------------------	
+        decod_queue_entry_t * entry = NULL;
+        for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	  {
+	    if (PORT_READ(in_DECOD_IN_VAL [i]) and internal_DECOD_IN_ACK[i])
+	      {
+		log_printf(TRACE,Decod_queue,FUNCTION,_("  * DECOD_IN  [%d]"),i);
+
+		if (entry == NULL)
+                 {
+                   // Once creation and insert in queue
+                   entry = new decod_queue_entry_t (_param->_nb_inst_decod);
+                   reg_QUEUE->push_back(entry);
+
+#ifdef STATISTICS
+                   if (usage_is_set(_usage,USE_STATISTICS))
+                     (*_stat_sum_transaction_decod_in) ++;
+#endif
+                 }
+
+#ifdef STATISTICS
+                if (usage_is_set(_usage,USE_STATISTICS))
+                  (*_stat_sum_inst_enable) ++;
+#endif
+
+		Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_DECOD_IN_CONTEXT_ID [i]):0;
+
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * context : %d"),context);
+
+		entry->_val           [i] = 1;
+		entry->_context_id    [i] = context;
+		entry->_depth         [i] = (_param->_have_port_depth)?PORT_READ(in_DECOD_IN_DEPTH [i]):0;
+		entry->_type          [i] = PORT_READ(in_DECOD_IN_TYPE          [i]);
+		entry->_operation     [i] = PORT_READ(in_DECOD_IN_OPERATION     [i]);
+		entry->_no_execute    [i] = PORT_READ(in_DECOD_IN_NO_EXECUTE    [i]);
+		entry->_is_delay_slot [i] = PORT_READ(in_DECOD_IN_IS_DELAY_SLOT [i]);
+#ifdef DEBUG
+		entry->_address       [i] = PORT_READ(in_DECOD_IN_ADDRESS       [i]);
+#endif
+		entry->_address_next  [i] = PORT_READ(in_DECOD_IN_ADDRESS_NEXT  [i]);
+		entry->_has_immediat  [i] = PORT_READ(in_DECOD_IN_HAS_IMMEDIAT  [i]);
+		entry->_immediat      [i] = PORT_READ(in_DECOD_IN_IMMEDIAT      [i]);
+		entry->_read_ra       [i] = PORT_READ(in_DECOD_IN_READ_RA       [i]);
+		entry->_num_reg_ra    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RA    [i]);
+		entry->_read_rb       [i] = PORT_READ(in_DECOD_IN_READ_RB       [i]);
+		entry->_num_reg_rb    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RB    [i]);
+		entry->_read_rc       [i] = PORT_READ(in_DECOD_IN_READ_RC       [i]);
+		entry->_num_reg_rc    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RC    [i]);
+		entry->_write_rd      [i] = PORT_READ(in_DECOD_IN_WRITE_RD      [i]);
+		entry->_num_reg_rd    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RD    [i]);
+		entry->_write_re      [i] = PORT_READ(in_DECOD_IN_WRITE_RE      [i]);
+		entry->_num_reg_re    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RE    [i]);
+		entry->_exception_use [i] = PORT_READ(in_DECOD_IN_EXCEPTION_USE [i]);
+		entry->_exception     [i] = PORT_READ(in_DECOD_IN_EXCEPTION     [i]);
+
+		reg_NB_INST [context] ++;
+
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * nb_inst : %d"),reg_NB_INST [context]);
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * PUSH queue"));
+	      }
+	  }
+
+	//--------------------------------------------------------------------
+	//-----[ DECOD_OUT ]--------------------------------------------------
+	//--------------------------------------------------------------------
+	if (not reg_QUEUE->empty())
+	  {
+ 	    bool find = false;
+	    
+	    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	      {
+		// Test transaction : if ok then invalid slot
+                // In order by rename logic
+		if (internal_DECOD_OUT_VAL [i] and internal_DECOD_OUT_ACK[i])
+		  {
+		    log_printf(TRACE,Decod_queue,FUNCTION,_("  * DECOD_OUT [%d]"),i);
+		
+#ifdef DEBUG_TEST
+                    if (reg_LAST_SLOT != i)
+                      throw ERRORMORPHEO(FUNCTION,toString(_("reg_LAST_SLOT (%d) is different at decod_out port (%d)."),reg_LAST_SLOT,i));
+#endif
+                    reg_LAST_SLOT ++;
+
+		    reg_QUEUE->front()->_val [i] = 0;
+
+		    Tcontext_t context = reg_QUEUE->front()->_context_id [i];
+		    log_printf(TRACE,Decod_queue,FUNCTION,_("    * context : %d"),context);
+		    
+		    reg_NB_INST [context] --;
+		    log_printf(TRACE,Decod_queue,FUNCTION,_("    * nb_inst : %d"),reg_NB_INST [context]);
+		  }
+		// Test if slot is (again) valid, if yes, then have less one instruction in the entry
+ 		find |= reg_QUEUE->front()->_val [i];
+	      }
+	    
+	    // test if can free the entry : test if have consume all entry
+            if (not find) // no valid instruction in current slot
+	      {
+		log_printf(TRACE,Decod_queue,FUNCTION,_("    * POP  queue"));
+
+		// can pop the slot
+		delete reg_QUEUE->front();
+		reg_QUEUE->pop_front();
+
+                reg_LAST_SLOT = 0;
+	      }
+	  }
+      }
+
+#if defined(DEBUG) and defined(DEBUG_Decod_queue) and (DEBUG >= DEBUG_TRACE)
+    log_printf(TRACE,Decod_queue,FUNCTION,"  * Dump decod_queue");
+    log_printf(TRACE,Decod_queue,FUNCTION,"    * reg_LAST_SLOT : %d",reg_LAST_SLOT);
+    uint32_t x=0;
+    for (std::list<decod_queue_entry_t*>::iterator it=reg_QUEUE->begin();
+	 it!=reg_QUEUE->end();
+	 it++)
+      {
+	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	  {
+	    if ((*it)->_val [i])
+	      log_printf(TRACE,Decod_queue,FUNCTION,"    * [%.4d][%.4d] %.1d, %.3d %.2d, %.2d %.3d %.1d %.1d, 0x%.8x (0x%.8x), %.1d 0x%.8x, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d"
+			 ,x
+                         ,i
+			 ,(*it)->_val           [i]
+			 ,(*it)->_context_id    [i]
+			 ,(*it)->_depth         [i]
+			 ,(*it)->_type          [i]
+			 ,(*it)->_operation     [i]
+			 ,(*it)->_no_execute    [i]
+			 ,(*it)->_is_delay_slot [i]
+			 ,(*it)->_address       [i]
+			 ,(*it)->_address       [i]<<2
+			 ,(*it)->_has_immediat  [i]
+			 ,(*it)->_immediat      [i]
+			 ,(*it)->_read_ra       [i]
+			 ,(*it)->_num_reg_ra    [i]
+			 ,(*it)->_read_rb       [i]
+			 ,(*it)->_num_reg_rb    [i]
+			 ,(*it)->_read_rc       [i]
+			 ,(*it)->_num_reg_rc    [i]
+			 ,(*it)->_write_rd      [i]
+			 ,(*it)->_num_reg_rd    [i]
+			 ,(*it)->_write_re      [i]
+			 ,(*it)->_num_reg_re    [i]
+			 ,(*it)->_exception_use [i]
+			 ,(*it)->_exception     [i]
+			 );
+	    else
+	      log_printf(TRACE,Decod_queue,FUNCTION,"    * [%.4d][%.4d] %d"
+			 ,x
+                         ,i
+			 ,(*it)->_val           [i]
+			 );
+
+	  }
+	x++;
+      }
+#endif
+    
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+        *(_stat_use_queue) += reg_QUEUE->size();
+        for (uint32_t i=0; i<_param->_nb_context; i++)
+          *(_stat_nb_inst [i]) += reg_NB_INST [i];
+      }
+#endif
+
+    log_end(Decod_queue,FUNCTION);
+  };
+
+}; // end namespace decod_queue
+}; // end namespace decod_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
